interface Integrierbar 
  {public double f (double x);}

class Kreis implements Integrierbar {
  public double f (double x)
  {return 4 * Math.sqrt(1 - x * x);}
  } // Ende Funktion

class Integration {
  
  static double Riemann (double a, double b, int n, Integrierbar Fkt) {
    // Riemann-Nherung im Intervall [a..b]
    double rechtecksumme = 0;
    double delta = (b - a)/n;
    double x = a + delta/2;
    for (int i = 0; i < n; i = i + 1) {
      rechtecksumme = rechtecksumme + Fkt.f(x);
      x = x + delta;
      } // Ende for
    return rechtecksumme * delta;
    } // Ende Riemann


  static void main (String[] xy) {
    
    double ergebnis = Integration.Riemann(0, 1, 100, new Kreis());
    System.out.println(ergebnis);
    
    } // Ende main
  } // Ende Integration
